<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Terminy\Listeners\Udalost;

use App\Models\Pouzivatel\Pouzivatel;
use App\Models\Pracovisko\Pracovisko;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Support\Facades\Notification;
use Seka\Portal\Modul\Terminy\Entities\Dtos\Factory\UdalostDTOFactory;
use Seka\Portal\Modul\Terminy\Events\Udalost\ZverejnenaUdalostBolaAktualizovana;
use Seka\Portal\Modul\Terminy\Notifications\Udalost\AktualizovanaUdalostNotifikaciaDB;
use Seka\Portal\Modul\Terminy\Notifications\Udalost\AktualizovanaUdalostNotifikaciaMail;

/**
 * Class AktualizovanaUdalostNotifikacia
 *
 * @package Seka\Portal\Modul\Terminy\Listeners\Udalost
 */
final class AktualizovanaUdalostNotifikacia implements ShouldQueue
{
    /**
     * @param \Seka\Portal\Modul\Terminy\Events\Udalost\ZverejnenaUdalostBolaAktualizovana $event
     */
    public function handle(ZverejnenaUdalostBolaAktualizovana $event)
    {
        if ($event->udalost->nieJePovoleneUpozornenie()) {
            return;
        }

        $udalost = UdalostDTOFactory::make($event->udalost);
        $udalostPovodna = UdalostDTOFactory::make($event->udalostPovodna);

        Notification::send(
            Pouzivatel::query()->aktivny()->get(),
            new AktualizovanaUdalostNotifikaciaDB($udalost)
        );

        Notification::send(
            collect(
                Pracovisko::query()->get()
            )->merge(
                Pouzivatel::query()->where('email', '!=', null)->aktivny()->get()
            ),
            new AktualizovanaUdalostNotifikaciaMail($udalost, $udalostPovodna)
        );
    }
}
